//----------------------------------------------------------------------
// De/Cruncher 1.0
// Copyleft 1999, Vander Nunes
//
// This is free software, provided AS IS - use it at your own risk.
// If you use this code, a mention is appreciated but not required.
//
// This code is released as a technique sample, not meant to be an
// example of elegancy or portability.
//
// Module: decrunch.h
//----------------------------------------------------------------------

#ifndef _DECRUNCH_H_
  #define _DECRUNCH_H_

  // sorry pals
  #include <windows.h>

  // buffered file io
  #define BUFFER_SIZE 16384

  // signature is "=VRNDCRNCH=" (ASCII -1 for each letter).
  // this was done to avoid duplication in exe file.
  #define CRUNCH_SIGNATURE "<UQMCBQMBG<"

  class CEntry
  {
    public:

      CEntry()
      {
        memset(cName,0,33);
        dwOffset = 0;
        dwSize = 0;
      }

      char  cName[33];    // name of crunched file
      DWORD dwOffset;     // file offset (counting list size but not counting exe filesize)
      DWORD dwSize;       // file size
  };

  class CCrunch
  {
    public:

      CEntry **m_pEntries;
      WORD m_wEntryCount;

      CCrunch();
      virtual ~CCrunch();

      // used when crunching files to the executable
      BOOL Crunch(char *ListFile, char *OutFile);

      // initialize decruncher with a crunched file
      // (this will NOT unpack, just read the file table)
      BOOL Decrunch(char *File, DWORD *dwOffset);
      
      // get the file count in the crunch
      WORD EntryCount() { return m_wEntryCount; };
      
      // get an entry from the list (name, offset and size)
      CEntry* Entry(WORD wIndex) { if (wIndex >= m_wEntryCount) return NULL; else return m_pEntries[wIndex]; };

      // clear entries
      void Reset(void);

    private:

      BOOL ReadList(char *SrcFile, DWORD ListOffset);
      CEntry* FindEntry(char *File);
  };

#endif
